#include "contiki.h"
#include "net/rime.h"
#include "random.h"

#include "dev/button-sensor.h"

#include "dev/leds.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/*---------------------------------------------------------------------------*/
PROCESS(example_broadcast_process, "Exemple de diffusion avec changement de couleur des led");
AUTOSTART_PROCESSES(&example_broadcast_process);
/*---------------------------------------------------------------------------*/
/* Fonction de réception des messages*/
static void
broadcast_recv(struct broadcast_conn *c, const rimeaddr_t *from)
{
  printf("SB: Message recu depuis %d.%d: '%s'\n", from->u8[0], from->u8[1], (char *)packetbuf_dataptr());
}
static const struct broadcast_callbacks broadcast_call = {broadcast_recv};
static struct broadcast_conn broadcast;
static uint16_t delai=20; // Définition du délai entre 2 envoie de messages
/*---------------------------------------------------------------------------*/
PROCESS_THREAD(example_broadcast_process, ev, data)
{
  static struct etimer et;
  static uint16_t count=0;
  char * messageenvoye = "";
  char id[10] = "";
  PROCESS_EXITHANDLER(broadcast_close(&broadcast);)

  PROCESS_BEGIN();

  broadcast_open(&broadcast, 129, &broadcast_call);

    /* On attends un peu avant de démarre l'envoi des message afin que tous les noeuds soient démarrés */
    etimer_set(&et, CLOCK_SECOND * delai/2 + random_rand() % (CLOCK_SECOND * delai/2));
    PROCESS_WAIT_EVENT_UNTIL(etimer_expired(&et));

  while(1) {
    count++; // On incrémente le compteur pour chaque message envoyé

    sprintf(id,"%d",count); // Le compteur sert d'identifiant pour le message
    strcpy(messageenvoye,"");
    messageenvoye=(char *)strcat(id,";bleue"); // On concatene l'identifiant et la couleur
    packetbuf_copyfrom(messageenvoye, strlen(messageenvoye)); // On crée le paquet à envoyé
    broadcast_send(&broadcast); // On diffuse le paquet
    printf("Envoi du message : %s\n", messageenvoye);
    count++;

    /* Attente de "delai" secondes */
    etimer_set(&et, CLOCK_SECOND * delai + random_rand() % (CLOCK_SECOND * delai));
    PROCESS_WAIT_EVENT_UNTIL(etimer_expired(&et));

    sprintf(id,"%d",count);
    strcpy(messageenvoye,"");
    messageenvoye=(char *)strcat(id,";rouge");
    packetbuf_copyfrom(messageenvoye, strlen(messageenvoye));
    broadcast_send(&broadcast);
    printf("Envoi du message : %s\n", messageenvoye);
    count++;

    /* Attente de "delai" secondes */
    etimer_set(&et, CLOCK_SECOND * delai + random_rand() % (CLOCK_SECOND * delai));
    PROCESS_WAIT_EVENT_UNTIL(etimer_expired(&et));

    sprintf(id,"%d",count);
    strcpy(messageenvoye,"");
    messageenvoye=(char *)strcat(id,";verte");
    packetbuf_copyfrom(messageenvoye, strlen(messageenvoye));
    broadcast_send(&broadcast);
    printf("Envoi du message : %s\n", messageenvoye);

    /* Attente de "delai" secondes */
    etimer_set(&et, CLOCK_SECOND * delai + random_rand() % (CLOCK_SECOND * delai));
    PROCESS_WAIT_EVENT_UNTIL(etimer_expired(&et));
  }

  PROCESS_END();
}
/*---------------------------------------------------------------------------*/
