#include "contiki.h"
#include "net/rime.h"
#include "random.h"

#include "dev/button-sensor.h"

#include "dev/leds.h"
#include <stdio.h>

/*---------------------------------------------------------------------------*/
PROCESS(example_broadcast_process, "Exemple de diffusion avec changement de couleur des led");
AUTOSTART_PROCESSES(&example_broadcast_process);
/*---------------------------------------------------------------------------*/
static char messagerecu[20]="";
static int recv=0;

/* Fonction de réceptions des messages */
static void broadcast_recv(struct broadcast_conn *c, const rimeaddr_t *from)
{
  static uint16_t idmsglast=0;
  char *message="";
  if (recv==0){// Si on n'est pas en cours de réception on peut traiter le message suivant
		recv=1;
		printf("Message recu depuis %d.%d: '%s'\n", from->u8[0], from->u8[1], (char *)packetbuf_dataptr());
		strcpy(messagerecu, (char *)packetbuf_dataptr());
		message = (char *)packetbuf_dataptr();
		printf("Message recu : %s\n", message);
		char * id = strtok (message, ";");
		char * couleur = strtok (NULL, ";");
		printf("- id recu : %s\n",id);
		printf("- couleur recue : %s\n",couleur);
		printf("ID %d,%d\n",idmsglast, atoi(id));
		if (idmsglast<atoi(id)){
		  printf("Allumage de la LED ");
		  idmsglast=atoi(id);
		  leds_off(LEDS_ALL);
		  if (strcmp(couleur,"bleue")==0){
		    leds_on(LEDS_BLUE);
		    printf("bleue\n");
		  }
		  else if (strcmp(couleur,"rouge")==0){
		    leds_on(LEDS_RED);
		    printf("rouge\n");
		  }
		  else if (strcmp(couleur,"verte")==0){
		    leds_on(LEDS_GREEN);
		    printf("verte\n");
		  }
		  else{
		    printf("inconnue '%s'",couleur);
		  }
  }
  else strcpy(messagerecu,"");
  recv=0;
  }
}

/*---------------------------------------------------------------------------*/
static const struct broadcast_callbacks broadcast_call = {broadcast_recv};
static struct broadcast_conn broadcast;
PROCESS_THREAD(example_broadcast_process, ev, data)
{
  static struct etimer et;
  PROCESS_BEGIN();
  broadcast_open(&broadcast, 129, &broadcast_call);
  while (1){
    /* Attente de 4 secondes */
    etimer_set(&et, CLOCK_SECOND * 4 + random_rand() % (CLOCK_SECOND * 4));
    PROCESS_WAIT_EVENT_UNTIL(etimer_expired(&et));
    if (recv==0){
		  if (strcmp(messagerecu,"")!=0){// Si un message a ete recu pour la premiere fois, on le renvoie 
		    packetbuf_copyfrom(messagerecu, strlen(messagerecu));
		    broadcast_send(&broadcast);
		    printf("Envoi du message : %s\n", messagerecu);
		    strcpy(messagerecu,"");
		  }
    }
  }
  PROCESS_END();
}
/*---------------------------------------------------------------------------*/
